package DUDeFolder;

import hashmap.DataJFrame;
import hashmap.DataJLabel;
import hashmap.DataJPanel;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

public class ClassReader {

    public static void Read(DataJFrame frame, String FormatDefLocation) throws FileNotFoundException {
        String line;
        BufferedReader reader = new BufferedReader(new FileReader(FormatDefLocation));

        try {
            DataJPanel currentPanel = null;
            String[] line_split;
            while ((line = reader.readLine()) != null) {
                line_split = line.split(",");
                if (line_split[0].equals("Panel")) {
                    if (currentPanel != null) {
                        frame.add(currentPanel);
                    }
                    String bordername = line_split[1];
                    int x = Integer.parseInt(line_split[2]);
                    int y = Integer.parseInt(line_split[3]);
                    int width = Integer.parseInt(line_split[4]);
                    int height = Integer.parseInt(line_split[5]);
                    currentPanel = new DataJPanel(width, height, bordername);
                    currentPanel.setBounds(x, y, width, height);
                } else if (line_split[0].equals("Label")) {
                    String prefix = line_split[1];
                    String name = line_split[2];
                    String suffix = line_split[3];
                    currentPanel.addLabel(new DataJLabel(name, prefix, suffix));
                }
            }

            frame.add(currentPanel);
        } catch (IOException e) {
            StatusPanel.AppendStatus(e.getStackTrace().toString());
        }

    }

}
