/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DUDeFolder;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JSeparator;
import javax.swing.JTextField;
import javax.swing.JPasswordField;
import javax.swing.SwingConstants;
import javax.swing.JOptionPane;
import java.sql.*;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.net.URL;
import java.math.BigInteger;



/**
 *
 * @author matthijs
 */
public class MenuBar extends JMenuBar{

JMenuItem item;
JMenu  menu;
static String user = null;
static String password = null;
static int userid = -2;
JTextField text1;
JPasswordField text2;
JButton button1;
JButton button2;
JButton button3;
JDialog settingsdialog;

public MenuBar(){
    super();
    menu = new JMenu("File");

    item = new JMenuItem("About DUDe");
    item.setActionCommand("about");
    item.addActionListener(new MenuActionListener());
    menu.add(item);

    item = new JMenuItem("Exit");
    item.setActionCommand("exit");
    item.addActionListener(new MenuActionListener());
    menu.add(item);

    this.add(menu);

    menu = new JMenu("Options");

    item = new JMenuItem("Settings");
    item.setActionCommand("settings");
    item.addActionListener(new MenuActionListener());
    menu.add(item);

    item = new JMenuItem("Show IV Curves");
    item.setActionCommand("curves");
    item.addActionListener(new MenuActionListener());
    menu.add(item);

    this.add(menu);
    
    File f = new File("Pass_" + SelectSatellite.abbrev + ".dat");
    if(f.exists()){
     try{   
        
       BufferedReader reader = new BufferedReader(new FileReader("Pass_" + SelectSatellite.abbrev + ".dat"));
       String[] line_split; String line;
       while((line = reader.readLine()) != null) {
                line_split = line.split(",");
                if(line_split.length >1) {
                  user = line_split[0];
                  password = line_split[1];
                } else {
                  user = "";
                  password = "";
                }
                   }
         
        }catch(IOException e){
            System.out.println(e.getStackTrace().toString());
   } 
     
  // Changed from here
  userid = login(user, password);
  if(userid < -1)
  System.out.println("Saved login fail");
    } else
  System.out.println("No Saved login");
 
 while(userid < -1) {
        ( (MenuActionListener) this.getMenu(1).getItem(0).getActionListeners()[0]).giveSettingsDialog();
  //while(settingsdialog.isDisplayable() && settingsdialog.isVisible()) {}
  //userid = login(user, password);
    }
 // To here
}


private class MenuActionListener implements ActionListener{

        public void actionPerformed(ActionEvent actionEvent) {
            String actioncommand = ((JMenuItem)actionEvent.getSource()).getActionCommand();

            if (actioncommand.equals("settings"))
           
            {StatusPanel.AppendStatus("settings");
            giveSettingsDialog();
            }

            if (actioncommand.equals("about"))
            {   StatusPanel.AppendStatus("about");
                showAboutDialog();
                
            }
            

            if (actioncommand.equals("exit"))
            {   StatusPanel.AppendStatus("Exit");
                System.exit(0);}

            if (actioncommand.equals("curves")){
                // <editor-fold defaultstate="collapsed" desc="curves">
       /* {if(IVframe != null)
                {
                IVframe.setVisible(true);
                return;
                }

                javax.swing.JFrame frame = new JFrame("IV Curves");
                frame.setDefaultCloseOperation(DISPOSE_ON_CLOSE);

                GridLayout grid = new GridLayout(2, 2);
                frame.setLayout(grid);

                frame.setBounds(30, 30, 700, 700);

                frame.add(curves[0]);
                frame.add(curves[1]);
                frame.add(curves[2]);
                frame.add(curves[3]);

                frame.setResizable(false);
                frame.setVisible(true);

                IVframe = frame;
                }*/// </editor-fold>

        }
        }
       private void showAboutDialog()
  {
         
   JDialog aboutdialog = new JDialog();
   aboutdialog.setBounds(200, 200, 300, 410);
   aboutdialog.setModal(true);
   aboutdialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

   aboutdialog.setTitle("About Delfi's DUDe");

   ImageIcon logo = new ImageIcon("lib/Q50.png");
   JLabel label = new JLabel(logo);
   label.setBounds(25, 10, 250, 100);
   aboutdialog.add(label);

   JSeparator sep = new JSeparator();
   sep.setBounds(0, 110, 300, 1);
   aboutdialog.add(sep);

   label = new JLabel("Delfi's DUDe");
   label.setBounds(0, 110, 300, 40);
   label.setHorizontalAlignment(SwingConstants.CENTER);
   label.setVerticalAlignment(SwingConstants.CENTER);
   label.setFont(new java.awt.Font("Verdana Plain", 1, 25));
   aboutdialog.add(label);

   label = new JLabel("Version " + Settings.version);
   label.setFont(new java.awt.Font("Verdana Plain", 0, 12));
   label.setBounds(0, 150, 300, 20);
   label.setHorizontalAlignment(SwingConstants.CENTER);
   aboutdialog.add(label);

   label = new JLabel("released " + Settings.releasedate);
   label.setFont(new java.awt.Font("Verdana Plain", 0, 12));
   label.setBounds(0, 170, 300, 20);
   label.setHorizontalAlignment(SwingConstants.CENTER);
   aboutdialog.add(label);

   sep = new JSeparator();
   sep.setBounds(0, 195, 300, 1);
   aboutdialog.add(sep);

   label = new JLabel("Development leads");
   label.setFont(new java.awt.Font("Verdana Plain", 1, 13));
   label.setBounds(10, 200, 300, 20);
   aboutdialog.add(label);

   label = new JLabel("<html>&nbsp;C 2011. All rights reserved. Disclosure to third parties of this document or any part thereof, or the use of any information contained therein for purposes other than provided for by this document, is not permitted, except prior and express written permission of Delft University of Technology.</html>");
   label.setFont(new java.awt.Font("Verdana Plain", 0, 12));
   label.setVerticalAlignment(SwingConstants.TOP);
   label.setBounds(25, 222, 250, 120);
   aboutdialog.add(label);


   aboutdialog.add(new JLabel());

   aboutdialog.setResizable(false);
   aboutdialog.setVisible(true);
  }

        private void giveSettingsDialog() {
            

            
            
            settingsdialog = new JDialog();
   settingsdialog.setModal(true);
            settingsdialog.setBounds(100,200,232,220);
            settingsdialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
            settingsdialog.setTitle("Settings for DUDe");

            settingsdialog.addWindowListener(new WindowAdapter() {
                @Override
               public void windowClosing(WindowEvent we){
                   settingsdialog.dispose();
                   settingsdialog.getOwner().dispose();
               }
            });

            settingsdialog.setLayout(new BorderLayout());

            JLabel label = new JLabel("Username ");
            label.setBounds(20, 20, 75, 20);
            settingsdialog.add(label);

            label = new JLabel("Password");
            label.setBounds(20,60,75,20);
            settingsdialog.add(label);

            text1 = new JTextField(user);
            text1.setBounds(130,20,75,20);
            settingsdialog.add(text1);

            text2 = new JPasswordField();
            text2.setBounds(130,60,75,20);
            settingsdialog.add(text2);

            JSeparator sep = new JSeparator();
            sep.setBounds(0,90,232,1);
            settingsdialog.add(sep);

            button1 = new JButton("save");
            button1.setBounds(20,100,75,30);
            settingsdialog.add(button1);
            button1.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    jButton1ActionPerformed(e);
                }
            });

            button2 = new JButton("cancel");
            button2.setBounds(130,100,90,30);
            settingsdialog.add(button2);
            button2.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    jButton2ActionPerformed(e);
                }
            });
   
   button3 = new JButton("exit DUDe");
            button3.setBounds(60,150,115,30);
            settingsdialog.add(button3);
            button3.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    jButton3ActionPerformed(e);
                }
            });
            settingsdialog.add(new JLabel());
            settingsdialog.setVisible(true);
        }
 }

public static String getUser(){
    return user;
}

public static String getPassword(){
    return password;
}

private void jButton3ActionPerformed(ActionEvent e) {
    // exit
    
    settingsdialog.dispose();
 System.exit(0);

}

private void jButton2ActionPerformed(ActionEvent e) {
    // cancel
 if(userid < 0)
   userid = 0;
 settingsdialog.dispose(); 

}

private void jButton1ActionPerformed(ActionEvent e){
    //save
     PrintWriter outputStream = null;
  String pass = new String( text2.getPassword() );
 
 
 int useridtmp = login(text1.getText(), pass);
 System.out.println(useridtmp);
 if(useridtmp > -1) {
     
        try {
          outputStream = new PrintWriter(new FileWriter("Pass_" + SelectSatellite.abbrev + ".dat"));
          outputStream.println(text1.getText() + "," + pass);
        }catch(IOException ex){
            System.out.println(ex.getStackTrace().toString());
        }finally {
                      
            if (outputStream != null) {
                outputStream.close();
            }
        }
    
  user = text1.getText();    //added
  password = pass; //added
  
  userid = useridtmp;
  
  settingsdialog.dispose();
 }
}



// ADDED
public static int getUserid() {
 return userid;
}


private int login(String username, String pass) {
 
 String md5_pass = "";
  try {
 MessageDigest md5 = MessageDigest.getInstance("MD5");
 
 
 /* make a double md5 hash from the password */
 md5.update(pass.getBytes(),0, pass.getBytes().length);
 BigInteger i = new BigInteger(1,md5.digest());
 md5.reset();
 
 md5.update(String.format("%1$032X", i).toLowerCase().getBytes(),0, String.format("%1$032X", i).getBytes().length);
 i = new BigInteger(1,md5.digest());
 md5.reset();
 md5_pass = String.format("%1$032X", i).toLowerCase();
 }
 catch(NoSuchAlgorithmException ex) {
  JOptionPane.showMessageDialog(this, "NoSuchAlgorithmException, EXITING",
                                            "Warning", JOptionPane.WARNING_MESSAGE);
      System.out.println("NoSuchAlgorithmException, EXITING");
      System.exit(0);
 }

 try {
    MessageDigest sh1 = MessageDigest.getInstance("SHA-1"); 
 
 
 /* check username/password combination with server */
 Statement stmt;
 Class.forName("com.mysql.jdbc.Driver");
 
 System.out.println("Attempting to connect to server \"jdbc:mysql://" + Main.satellite.getServerOne() + "/" + Settings.userdb + "\"");
 Connection con = DriverManager.getConnection("jdbc:mysql://" + Main.satellite.getServerOne() + "/" + Settings.userdb, Settings.racheck_username, Settings.racheck_password);
 System.out.println("Connected to server");
 
 stmt = con.createStatement();   
   
 sh1.update((username + "" + md5_pass).getBytes(),0, (username + "" + md5_pass).getBytes().length);
 BigInteger i = new BigInteger(1,sh1.digest());
 sh1.reset();
 String where =  String.format("%1$040X", i).toLowerCase();
 
 
 ResultSet rs;
 
 rs = stmt.executeQuery("SELECT * FROM `radio_amateurs` WHERE SHA1(CONCAT(`username`, `password`)) = '" + where + "'");
 
 
 System.out.println("Verifying username/password combination");
 rs.next();
 /* check if anything was returned */
 if(rs.getRow() > 0) {
   /* set the userid */
   System.out.println("Now logged in as " + username + ", userid " + rs.getInt("id"));
   return rs.getInt("id");
 } else {
   System.out.println("Wrong username/password combination");
   JOptionPane.showMessageDialog(this, "Wrong username/password combination",
                                            "Warning", JOptionPane.WARNING_MESSAGE);
   return -1;
 }
 
 } catch(SQLException e) {
   JOptionPane.showMessageDialog(this, "CONNECTION TO SERVER FAILED",
                                            "Warning", JOptionPane.WARNING_MESSAGE);
      System.out.println("CONNECTION TO SERVER FAILED");
      //System.exit(0);
   
   return 0;
    }
 catch(ClassNotFoundException e) {
  JOptionPane.showMessageDialog(this, "ClassNotFoundException, EXITING",
                                            "Warning", JOptionPane.WARNING_MESSAGE);
      System.out.println("ClassNotFoundException, EXITING");
      System.exit(0);
   
   return -1;
 }
 catch(NoSuchAlgorithmException e) {
  JOptionPane.showMessageDialog(this, "NoSuchAlgorithmException, EXITING",
                                            "Warning", JOptionPane.WARNING_MESSAGE);
      System.out.println("NoSuchAlgorithmException, EXITING");
      System.exit(0);
   
   return -1;
 }
}


}

