package hashmap;
/**
 *
 * @author Matthijs Kuiper
 */
public class Variable {
    protected String name;
    protected double multiplier;
    protected double sommation;
    protected int bit_start;
    protected int bit_length;

    /**
     *
     * @param name_in           the name of the variable
     * @param multiplier_in     The value to multiply with
     * @param sommation_in      the value to add to the base
     * @param bit_start_in      begin of the bit within the frame
     * @param bit_length_in     lenght of the subframe to be used
     */

    Variable(String name_in, double multiplier_in, double sommation_in, int bit_start_in, int bit_length_in){
        name = name_in;
        multiplier = multiplier_in;
        sommation = sommation_in;
        bit_start = bit_start_in;
        bit_length = bit_length_in;
    }

    public String getName(){
        return name;
    }

    public double getMultiplier(){
        return multiplier;
    }

    public double getSommation(){
        return sommation;
    }

    public int getBit_start(){
        return bit_start;
    }

    public int getBit_length(){
        return bit_length;
    }

    public int getBit_end(){
        return bit_start + bit_length;
    }
}
