/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DUDeFolder;

import java.awt.Color;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import javax.swing.border.TitledBorder;

/**
 *
 * @author matthijs
 */
public class StatusPanel extends JPanel {

    private final static java.awt.Font plainfont = new java.awt.Font("Verdana Plain", 0, 11);
    private final static java.awt.Font boldfont = new java.awt.Font("Verdana Plain", 1, 11);
    private JLabel status_packetsrx, status_updatetime;
    private static JLabel status_rep1_ondisk, status_rep1_sent, status_rep2_ondisk, status_rep2_sent;
    private static JTextArea status_msgarea;
    static JTextArea area;

    public StatusPanel() {
        this.setBorder(new TitledBorder("Status messages"));

        this.setBounds(780, 480, 460, 175);

        JLabel label = new JLabel("Packets received:");
        this.add(label);
        label.setFont(boldfont);
        label.setBounds(10, 15, 110, 20);

        label = new JLabel("0");
        this.add(label);
        label.setFont(plainfont);
        label.setHorizontalAlignment(SwingConstants.TRAILING);
        label.setBounds(120, 15, 30, 20);

        status_packetsrx = label;

        label = new JLabel("Last packet received:");
        this.add(label);
        label.setFont(boldfont);
        label.setBounds(170, 15, 120, 20);

        label = new JLabel("never");
        this.add(label);
        label.setFont(plainfont);
        label.setHorizontalAlignment(SwingConstants.TRAILING);
        label.setBounds(285, 15, 110, 20);

        status_updatetime = label;

        label = new JLabel("Primary repository");
        this.add(label);
        label.setFont(boldfont);
        label.setHorizontalAlignment(SwingConstants.CENTER);
        label.setBounds(10, 35, 190, 20);

        label = new JLabel("Secondary repository");
        this.add(label);
        label.setFont(boldfont);
        label.setHorizontalAlignment(SwingConstants.CENTER);
        label.setBounds(200, 35, 190, 20);

        label = new JLabel("Disk:");
        this.add(label);
        label.setFont(boldfont);
        label.setBounds(15, 55, 35, 20);

        label = new JLabel("0");
        this.add(label);
        label.setFont(plainfont);
        label.setHorizontalAlignment(SwingConstants.TRAILING);
        label.setBounds(50, 55, 40, 20);

        status_rep1_ondisk = label;

        label = new JLabel("Sent:");
        this.add(label);
        label.setFont(boldfont);
        label.setBounds(105, 55, 40, 20);

        label = new JLabel("0");
        this.add(label);
        label.setFont(plainfont);
        label.setHorizontalAlignment(SwingConstants.TRAILING);
        label.setBounds(145, 55, 40, 20);

        status_rep1_sent = label;

        label = new JLabel("Disk:");
        this.add(label);
        label.setFont(boldfont);
        label.setBounds(205, 55, 35, 20);

        label = new JLabel("0");
        this.add(label);
        label.setFont(plainfont);
        label.setHorizontalAlignment(SwingConstants.TRAILING);
        label.setBounds(240, 55, 40, 20);

        status_rep2_ondisk = label;

        label = new JLabel("Sent:");
        this.add(label);
        label.setFont(boldfont);
        label.setBounds(295, 55, 40, 20);

        label = new JLabel("0");
        this.add(label);
        label.setFont(plainfont);
        label.setHorizontalAlignment(SwingConstants.TRAILING);
        label.setBounds(340, 55, 40, 20);

        status_rep2_sent = label;

        JSeparator sep = new JSeparator();
        this.add(sep);
        sep.setForeground(java.awt.Color.BLACK);
        sep.setBounds(5, 35, 1, 40);
        sep.setOrientation(SwingConstants.VERTICAL);

        sep = new JSeparator();
        this.add(sep);
        sep.setForeground(java.awt.Color.BLACK);
        sep.setBounds(200, 35, 1, 40);
        sep.setOrientation(SwingConstants.VERTICAL);

        sep = new JSeparator();
        this.add(sep);
        sep.setForeground(java.awt.Color.BLACK);
        sep.setBounds(395, 35, 1, 40);
        sep.setOrientation(SwingConstants.VERTICAL);

        sep = new JSeparator();
        this.add(sep);
        sep.setForeground(java.awt.Color.BLACK);
        sep.setBounds(5, 35, 391, 1);
        sep.setOrientation(SwingConstants.HORIZONTAL);

        sep = new JSeparator();
        this.add(sep);
        sep.setForeground(java.awt.Color.GRAY);
        sep.setBounds(5, 55, 391, 1);
        sep.setOrientation(SwingConstants.HORIZONTAL);

        sep = new JSeparator();
        this.add(sep);
        sep.setForeground(java.awt.Color.BLACK);
        sep.setBounds(5, 75, 391, 1);
        sep.setOrientation(SwingConstants.HORIZONTAL);

        //this.updateRepositoryData(); 
// A function needs to be created to update the repository, this needs to be linked to the DB on the disk.
// The lines in the local DB can be counted and the lines allready send during the sesion can be counted as well
// This is a function copied from RASCAL and needs some tweaking due to the change from RMI to SQL.
        
        
        area = new JTextArea(7,49);
        area.setFont(new java.awt.Font("DejaVu Serif", 0, 10));
	area.setBackground(new Color(0, 0, 0));
	area.setForeground(new Color(255, 255, 255));
	area.setAutoscrolls(true);
	area.setLineWrap(true);
	area.setEditable(false);
        
        JScrollPane pane = new JScrollPane(area);
        pane.setViewportView(area);
        this.add(pane);
        pane.setBounds(10,85,380,70);

        this.add(new JLabel());
    }
    public static void AppendStatus(String text){
        
		String messagestring = "[";
		java.util.Date date = new java.util.Date();
		java.text.DateFormat format = new java.text.SimpleDateFormat("kk:mm:ss");
		messagestring += format.format(date) + "] " + text + "\n";
		area.append(messagestring);
    }
}
